#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gun2dragon4uri.py">
#<abstract4xi abstract = "gun dragon activating processes with target functions to check local hyperlinks in HTML files"/>
#<refer4xi reference = "automate2ref4uri.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
# modify behaviour:
#    ack2function = False (default) <-- False to use function directly to shoot - blocks return TO MainProcess4Xi
#    ack2ready4cc = True  (default) <-- False, if module is not ready for command and control via queue and named pipe
#    ack2process = True   (default) <-- False, if Process4Xi is not used
#    ack2dummy = True     (default) <-- False, if DummyProcess4Xi is not used i.e. target function will be performed first before retuning
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'gun2dragon4uri']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system
    import os
    import sys
    import signal
except:
    pass
try:                 # threading       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common
    import weakref
    import array
    import itertools
    from queue import Queue         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary
    import _multiprocessing
except:
    pass
try:                             # Python 
    from multiprocessing import TimeoutError, cpu_count
    from multiprocessing.dummy.connection import Pipe
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Special Imports                          
# -------------------------------------------------------------------------------------------------
#<specialize4xi speciality = "
from threading import Lock, RLock, Semaphore, BoundedSemaphore
from threading import Event
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2dragon4uri: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2dragon4uri: *** error: from process4xi import Process4Xi ***")    
     
from shoot2dragon4uri import shoot2dragon4uri

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug4dragon
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug4dragon = True      
#"
#"/>
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "gun2dragon4uri" usage = "
#   gun for Process4Xi-1
#   commands and control via queue and pipe
#"> 
# -----------------------------------------------------------------------------------------------------
       
def gun2dragon4uri(queue2work = None, channel2consume = None, channel2publish = None, path2dragon = None):
    '''
    guns for Process4Xi-1
    '''    
    global ack2debug4dragon       
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    if ack2debug4dragon is True:
        
        print("(STEP 0/33) OF GUN2DRAGON4SEARCH, START TIME: ", time4xi())      
        
        # 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------       
    queue2work4dragon = queue2work
    
    if ack2debug4dragon is True:
        print("(STEP 1/33) OF GUN2DRAGON4SEARCH, QUEUE2WORK4DRAGON: ", queue2work4dragon)
        # <queue4xi.Queue4Xi object at 0x02AA32F0> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2consume4dragon = channel2consume
    if ack2debug4dragon is True:
        print("(STEP 2/33) OF GUN2DRAGON4SEARCH, CHANNEL2CONSUME4DRAGON: ", channel2consume4dragon)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x02306E70>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2publish4dragon = channel2publish
    if ack2debug4dragon is True:
        print("(STEP 3/33) OF GUN2DRAGON4SEARCH, CHANNEL2PUBLISH4DRAGON: ", channel2publish4dragon)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x02AA32B0> 

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    path2search4dragon = path2dragon
    if ack2debug4dragon is True:
        print("(STEP 4/33) OF GUN2DRAGON4SEARCH, PATH2SEARCH4DRAGON: ", path2search4dragon)
        # F://temp//yosense//test2dragon//
    
    ack2process = True        
    # ---------------------------------------------------------------------------------------------    
    # GETTING COMMAND AND CONTROL (CC) FROM QUEUE - CALLER MUST HAVE PUT CC-DATA 
    # --------------------------------------------------------------------------------------------- 
    if not(queue2work4dragon is None):    
        try:
            message2qet4dragon = queue2work4dragon.get()
            if ack2debug4dragon is True:
                print("(STEP 5A/33) OF GUN2DRAGON4SEARCH - MESSAGE2QET4DRAGON GOT: ", message2qet4dragon)  
                # <copy4xi>copy2dragon</copy4xi> 
                
            if message2qet4dragon == "<copy4xi>copy2dragon</copy4xi>":
                message2put4dragon = "<roger4xi>roger2dragon</roger4xi>"
                if ack2debug4dragon is True:
                    print("(STEP 5B/33) OF GUN2DRAGON4SEARCH - SET MESSAGE2PUT4DRAGON TO: ", message2put4dragon) 
                    # <roger4xi>roger2dragon</roger4xi> 
            else:
                if ack2debug4dragon is True:
                    print("(STEP 5C/33) OF GUN2DRAGON4SEARCH - *** UNREGONIZED MESSAGE, GOT: ", message2qet4dragon)
                    #           
                message2put4dragon = "<negative4xi>negative2dragon</negative4xi>"
                if ack2debug4dragon is True:
                    print("(STEP 5D/33) OF GUN2DRAGON4SEARCH - SET MESSAGE2PUT4DRAGON TO: ", message2put4dragon)
                    #              
        except:
            message2put4dragon = "<negative4xi>negative2dragon</negative4xi>"
            print("(STEP 5Z/33) OF GUN2DRAGON4SEARCH *** EXCEPTION, SET MESSAGE2PUT4DRAGON TO: ", message2put4dragon)  
            ack2process = False
        # ---------------------------------------------------------------------------------------------    
        # PUTTING COMMAND AND CONTROL (CC) FROM QUEUE TO QUEUE- CALLER PREPARED TO GET CC-DATA  
        # --------------------------------------------------------------------------------------------- 
        print("(STEP 6A/33) OF GUN2DRAGON4SEARCH - TRYING TO PUT MESSAGE2PUT4DRAGON: ", message2put4dragon)                                  
        # 
        try:         
            queue2work4dragon.put(message2put4dragon) 
            if ack2debug4dragon is True:
                print("(STEP 6B/33) OF GUN2DRAGON4SEARCH - PUT TO QUEUE2WORK4DRAGON: ", queue2work4dragon, ' MESSAGE2PUT4DRAGON: ', message2put4dragon)
                # PUT TO QUEUE2WORK4DRAGON:  <queue4xi.Queue4Xi object at 0x02AA32F0>  MESSAGE2PUT4DRAGON:  <roger4xi>roger2dragon</roger4xi> 
                
        except:
            print("(STEP 6Z/33) OF GUN2DRAGON4SEARCH *** FAILED TO PUT TO QUEUE2WORK4DRAGON: ", queue2work4dragon, ' MESSAGE2PUT4DRAGON: ', message2put4dragon)
            ack2process = False
      
    if not(channel2consume4dragon is None):
        # -----------------------------------------------------------------------------------------------    
        # RECEIVING COMMAND AND CONTROL (CC) MESSAGE FROM PIPE CONSUMER CHANNEL - CALLER HAS SENT CC-DATA 
        # -----------------------------------------------------------------------------------------------  
        if ack2debug4dragon is True:
            print("(STEP 7A/33) OF GUN2DRAGON4SEARCH - TRYING TO RECEIVE FROM CHANNEL2CONSUME4DRAGON: ", channel2consume4dragon)
            # TRYING TO RECEIVE FROM CHANNEL2CONSUME4DRAGON:  <pipeconnection4xi.PipeConnection4Xi object at 0x02306E70>
        try:
            message2receive4dragon = channel2consume4dragon.recv()
            if ack2debug4dragon is True:
                print("(STEP 7B/33) OF GUN2DRAGON4SEARCH - RECEIVED MESSAGE2RECEIVE4DRAGON: ", message2receive4dragon)
                # <copy4xi>copy2dragon</copy4xi>
                
            if message2receive4dragon == "<copy4xi>copy2dragon</copy4xi>":
                message2send4dragon = "<roger4xi>roger2dragon</roger4xi>"
                if ack2debug4dragon is True:
                    print("(STEP 7C/33) OF GUN2DRAGON4SEARCH - SET MESSAGE2SEND4DRAGON: ", message2send4dragon)
                    # <roger4xi>roger2dragon</roger4xi>
            else:
                message2send4dragon = "<negative4xi>negative2dragon</negative4xi>"
                if ack2debug4dragon is True:
                    print("(STEP 7D/33) OF GUN2DRAGON4SEARCH - SET MESSAGE2SEND4DRAGON: ", message2send4dragon)        
        except:
            print("(STEP 7Z1/33) OF GUN2DRAGON4SEARCH - *** EXCEPTION WITH CHANNEL2CONSUME4DRAGON.RECV: ", channel2consume4dragon.recv) 
            message2send4dragon = "<negative4xi>negative2dragon</negative4xi>"
            print("(STEP 7Z2/33) OF GUN2DRAGON4SEARCH - SET MESSAGE2SEND4DRAGON: ", message2send4dragon)
            ack2process = False       
    else:
        if ack2debug4dragon is True:
            print("(STEP 7E/33) OF GUN2DRAGON4SEARCH - SKIPPED RECEIVING FROM CHANNEL2CONSUME4DRAGON: ", channel2consume4dragon)
            #     
                
    if not(channel2publish4dragon is None):
        # -----------------------------------------------------------------------------------------------
        # SENDING COMMAND AND CONTROL (CC) MESSAGE TO THE PIPE'S PUBLISHER CHANNEL - CALLER TO RECEIVE IT 
        # -----------------------------------------------------------------------------------------------
        if ack2debug4dragon is True:
            print("(STEP 8A/33) OF GUN2DRAGON4SEARCH - TRYING TO SEND COMMAND AND CONTROL TO CHANNEL2PUBLISHER4DRAGON: ", channel2publish4dragon)
            # 
        try:         
            channel2publish4dragon.send(message2send4dragon)
            if ack2debug4dragon is True:
                print("(STEP 8B/33) OF GUN2DRAGON4SEARCH - SENT MESSAGE2SEND4DRAGON: ", message2send4dragon, " CHANNEL2PUBLISHER4DRAGON: ", channel2publish4dragon)
                # SENT MESSAGE2SEND4DRAGON:  <roger4xi>roger2dragon</roger4xi>  CHANNEL2PUBLISHER4DRAGON:  <pipeconnection4xi.PipeConnection4Xi object at 0x02AA32B0> 
        except:
            print("(STEP 8Z1/33) OF GUN2DRAGON4SEARCH - *** FAILED TO SEND MESSAGE2SEND4DRAGON: ", message2send4dragon, " CHANNEL2PUBLISHER4DRAGON: ", channel2publish4dragon) 
    else:
        if ack2debug4dragon is True:
            print("(STEP 8C/33) OF GUN2DRAGON4SEARCH - SKIPPED SENDING COMMAND AND CONTROL TO THE PIPE'S PUBLISHER CHANNEL : ", channel2publish4dragon)
            # 
        ack2process = False
        
    if ack2process is True:
        # -----------------------------------------------------------------------------------------------------------------    
        # USING THE DUMMY PROCESS TO SHOOT - THIS APPROACH ALLOWS FAST RETURN TO MainProcess4Xi ALLOWING CALLER TO CONTINUE  
        # -----------------------------------------------------------------------------------------------------------------      
        if ack2debug4dragon is True:
            print("(STEP 10A/33) OF GUN2DRAGON4SEARCH - CREATING A DUMMY PROCESS4XI")  
        
        ack2dummy = False
        
        # -----------------------------------------------------------------------------------------    
        # CREATE THE DUMMY PROCESS OBJECT 
        # -----------------------------------------------------------------------------------------           
        try:
            dummy2dragon= DummyProcess4Xi(target=shoot2dragon4uri, 
                                         args =(queue2work4dragon,
                                                channel2consume4dragon, channel2publish4dragon,
                                                path2search4dragon))
            if ack2debug4dragon is True:
                print("(STEP 10B/33) OF GUN2DRAGON4SEARCH - CREATED DUMMY_PROCESS4XI OBJECT DUMMY2DRAGON: ", dummy2dragon)
                # CREATED DUMMY_PROCESS4XI OBJECT DUMMY2DRAGON:  <DummyProcess4Xi(Thread-1, initial)>
            
            ack2dummy = True
        except:
            print("(STEP 10Z/33) OF GUN2DRAGON4SEARCH *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT DUMMY2DRAGON ***")
            ack2dummy = False
            
        # -----------------------------------------------------------------------------------------    
        # START THE DUMMY PROCESS OBJECT
        # -----------------------------------------------------------------------------------------              
        if ack2dummy is True:
            if ack2debug4dragon is True:
                print("(STEP 10D/33) OF GUN2DRAGON4SEARCH - STARTING THE DUMMY PROCESS4XI TIME: ", time4xi())
                # 10:50:51 02/25/15 FLE Standard Time
            ack2start = False
            try:      
                dummy2dragon.start() 
                if ack2debug4dragon is True:
                    print("(STEP 10E/33) OF GUN2DRAGON4SEARCH - STARTED THE DUMMY PROCESS4XI DUMMY2DRAGON: ", dummy2dragon)
                    # STARTING THE DUMMY PROCESS4XI TIME:  10:50:51 02/25/15 FLE Standard Time
                
                #NOTES:
                # [1] function shoot2dragon4uri starts immediatelly AND lets this function to return to MainProcess4Xi 
                # [2] debug messages get mixed - dragon reason to use dragonized trace !
                # 
                #                 
                
                ack2start = True
            except:
                print("(STEP 10Z/33) OF GUN2DRAGON4SEARCH *** FAILED TO START THE DUMMY PROCESS4XI ***")

        else:
            if ack2debug4dragon is True:
                print("(STEP 10G/33) OF GUN2DRAGON4SEARCH ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy)
            ack2start = False
             
    else:
        print("(STEP 10H/33) OF GUN2DRAGON4SEARCH ** YIELDED STARTING THE DUMMY PROCESS4XI ", time4xi())
                                
           
    # ---------------------------------------------------------------------------------------------    
    # RETURN
    # ---------------------------------------------------------------------------------------------     
    if ack2debug4dragon is True:
        print("(STEP 11/33) OF GUN2DRAGON4SEARCH - RETURNING TIME: ", time4xi())
        # 10:50:51 02/25/15 FLE Standard Time
        
    return
    
        
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\automate2ref4uri.txt
# dummy2dragon\xml\ace-automate2ref4uri.xml
# dummy2dragon\xml\reason-automate2ref4uri.xml
# dummy2dragon\xml\sense-automate2ref4uri.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gun2dragon4uri.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
